View Issue Details

IDProjectCategoryView StatusLast Update
0004243unrealircdpublic2013-11-23 11:42
ReporterkotokoAssigned Tosyzop 
PriorityurgentSeveritycrashReproducibilityrandom
Status resolvedResolutionfixed 
PlatformLinuxOSDebianOS Version6
Product Version3.2.10.1 
Target VersionFixed in Version3.2.10.2 
Summary0004243: Intermittent crashes of the ircd when a user joins
DescriptionOn a network of approx 400 users, the ircd will randomly crash in intervals of between a couple days and a couple weeks. Since the crash seems MOTD related, here's the one currently in use: https://pastee.org/9cade

The backtrace is attached. Services are run through Anope.
TagsNo tags attached.
3rd party modules

Activities

kotoko

2013-11-03 18:08

reporter  

backtrace.txt (3,137 bytes)

syzop

2013-11-03 21:56

administrator   ~0017831

Thanks for the report.

Could you send over the following files to syzop@unrealircd.com or upload them somewhere and post a link?
1) The file named 'core'
2) The ircd binary, usually 'src/ircd'
3) commands.so, usually 'src/modules/commands.so'

This would enable me to look into this crash in more detail.

Thanks!

kotoko

2013-11-04 19:20

reporter   ~0017832

Email sent—thanks for looking into this!

syzop

2013-11-04 21:26

administrator   ~0017834

Thanks a lot. There seems to be a problem in 3.2.10's I/O engine.
I'll verify my theory & find a proper solution and (stress) test it... this may take a few days as I have to work extra at my other (paid) job. The final solution is probably only to change a few lines, but of course this needs to be done with great care.. don't want to create a new issue when resolving the first one :)

Thanks again for the core dump and other files, this helped a lot.

kotoko

2013-11-09 08:13

reporter   ~0017835

Just an update: it crashed twice today again. If you'd like more core dumps, I can provide them.

syzop

2013-11-09 13:49

administrator   ~0017836

Last edited: 2013-11-09 13:50

View 2 revisions

If you can, try this patch:
http://www.vulnscan.org/tmp/3.2.10.1-f1.patch

On the shell you type, in your Unreal3.2.10.1 directory:
patch --dry-run -p1 </the/location/to/3.2.10.1-f1.patch
If this does not raise any alarm bells (should be just 'Patching ...' with some possible 'FUZZ', nothing else), then run the command for real:
patch -p1 </the/location/to/3.2.10.1-f1.patch

Once the patch is applied, re-run 'make', and 'make install'

The IRCd then needs to be restarted, unfortunately a /REHASH or reload is insufficient.

This patch actually addresses a number of issues.

Let me know your results, especially if they are negative ;)

kotoko

2013-11-09 21:05

reporter   ~0017838

Just applied the patch and restarted the server: so far so good. Sometimes it would take a number of days for the bug to manifest, so I'll keep monitoring it.

syzop

2013-11-09 21:17

administrator   ~0017839

Ok, thanks :)

kotoko

2013-11-16 18:31

reporter   ~0017840

After a week, the IRCd is still stable. Thanks for taking care of this issue so quickly!

syzop

2013-11-17 15:03

administrator   ~0017841

Great. Thanks for letting me know.

syzop

2013-11-23 11:40

administrator   ~0017843

Thanks for your help in this, really appreciated.

This issue has been resolved in 3.2.10.2 (using the same patch as linked earlier)

Issue History

Date Modified Username Field Change
2013-11-03 18:08 kotoko New Issue
2013-11-03 18:08 kotoko File Added: backtrace.txt
2013-11-03 21:45 syzop View Status public => private
2013-11-03 21:56 syzop Note Added: 0017831
2013-11-03 21:56 syzop Assigned To => syzop
2013-11-03 21:56 syzop Status new => acknowledged
2013-11-03 21:57 syzop Priority normal => urgent
2013-11-04 19:20 kotoko Note Added: 0017832
2013-11-04 21:26 syzop Note Added: 0017834
2013-11-09 08:13 kotoko Note Added: 0017835
2013-11-09 13:49 syzop Note Added: 0017836
2013-11-09 13:50 syzop Note Edited: 0017836 View Revisions
2013-11-09 13:53 syzop Status acknowledged => assigned
2013-11-09 21:05 kotoko Note Added: 0017838
2013-11-09 21:17 syzop Note Added: 0017839
2013-11-16 18:31 kotoko Note Added: 0017840
2013-11-17 15:03 syzop Note Added: 0017841
2013-11-23 11:40 syzop Note Added: 0017843
2013-11-23 11:40 syzop Status assigned => resolved
2013-11-23 11:40 syzop Fixed in Version => 3.2.10.2
2013-11-23 11:40 syzop Resolution open => fixed
2013-11-23 11:42 syzop View Status private => public
2014-03-14 01:14 peterkingalexander Issue cloned: 0004280